From e412747e6faca4ef0d824fd3774b537db0573b5c Mon Sep 17 00:00:00 2001
From: zhoukang <gameoverboss@163.com>
Date: Tue, 12 Jul 2022 13:35:10 +0000
Subject: [PATCH] git-lfs: upgrade to latest release

Upgrade to latest release

Signed-off-by: zhoukang <gameoverboss@163.com>
---
 0001-use-vendor-dir-for-build.patch |  59 +++++++++++++++-------------
 git-lfs-v2.12.0.tar.gz              | Bin 2847273 -> 0 bytes
 git-lfs-v3.2.0.tar.gz               | Bin 0 -> 3270970 bytes
 git-lfs.spec                        |   9 ++---
 4 files changed, 34 insertions(+), 34 deletions(-)
 delete mode 100644 git-lfs-v2.12.0.tar.gz
 create mode 100644 git-lfs-v3.2.0.tar.gz

diff --git a/0001-use-vendor-dir-for-build.patch b/0001-use-vendor-dir-for-build.patch
index d4712a7..6ba7f65 100644
--- a/0001-use-vendor-dir-for-build.patch
+++ b/0001-use-vendor-dir-for-build.patch
@@ -1,17 +1,17 @@
-From 2e4c2e8b73dee54dd3fa8a81325701f7295a3355 Mon Sep 17 00:00:00 2001
-From: gameoverboss <gameoverboss@163.com>
-Date: Wed, 21 Oct 2020 19:43:42 +0800
+From f17333fb29d81d5061c96931c0cd5135dec0ba02 Mon Sep 17 00:00:00 2001
+From: zhoukang <gameoverboss@163.com>
+Date: Tue, 12 Jul 2022 21:21:58 +0800
 Subject: [PATCH] use vendor dir for build
 
 ---
- Makefile | 24 ++++++++++++------------
- 1 file changed, 12 insertions(+), 12 deletions(-)
+ Makefile | 20 +++++++-------------
+ 1 file changed, 7 insertions(+), 13 deletions(-)
 
 diff --git a/Makefile b/Makefile
-index bd83e21..4d47289 100644
+index 0b73d9e..a185116 100644
 --- a/Makefile
 +++ b/Makefile
-@@ -21,7 +21,7 @@ GO_TEST_EXTRA_ARGS =
+@@ -24,7 +24,7 @@ GO_TEST_EXTRA_ARGS =
  # BUILTIN_LD_FLAGS are the internal flags used to pass to the linker. By default
  # the config.GitCommit variable is always set via this variable, and
  # DWARF-stripping is enabled unless DWARF=YesPlease.
@@ -20,7 +20,7 @@ index bd83e21..4d47289 100644
  ifneq ("$(VENDOR)","")
  BUILTIN_LD_FLAGS += -X github.com/git-lfs/git-lfs/config.Vendor=$(VENDOR)
  endif
-@@ -163,8 +163,8 @@ endif
+@@ -194,8 +194,8 @@ endif
  #
  # It uses BUILD_MAIN as defined above to specify the entrypoint for building Git
  # LFS.
@@ -30,26 +30,35 @@ index bd83e21..4d47289 100644
 +	$(GO) build -mod=vendor \
  	-ldflags="$(LD_FLAGS)" \
  	-gcflags="$(GC_FLAGS)" \
- 	-asmflags="$(ASM_FLAGS)" \
-@@ -195,7 +195,7 @@ mangen : commands/mancontent_gen.go
+ 	-trimpath \
+@@ -227,7 +227,7 @@ mangen : commands/mancontent_gen.go
  # 'commands' of Git LFS. It depends upon the contents of the 'docs' directory
  # and converts those manpages into code.
  commands/mancontent_gen.go : $(wildcard docs/man/*.ronn)
--	$(GO) generate github.com/git-lfs/git-lfs/commands
-+	#$(GO) generate github.com/git-lfs/git-lfs/commands
+-	GOOS= GOARCH= $(GO) generate github.com/git-lfs/git-lfs/v3/commands
++	@echo "delete this step"
  
- # Targets 'all' and 'build' build binaries of Git LFS for the above release
- # matrix.
-@@ -503,7 +503,7 @@ vendor : go.mod
+ # trgen is a shorthand for ensuring that tr/tr_gen.go is kept up-to-date with
+ # the contents of po/build/*.mo.
+@@ -238,7 +238,7 @@ trgen : tr/tr_gen.go
+ # 'tr' of Git LFS. It depends upon the contents of the 'po' directory
+ # and converts the .mo files.
+ tr/tr_gen.go : $(MO)
+-	GOOS= GOARCH= $(GO) generate github.com/git-lfs/git-lfs/v3/tr
++	@echo "delete this step"
+ 
+ po/build:
+ 	mkdir -p po/build
+@@ -597,7 +597,7 @@ vendor : go.mod
  .PHONY : fmt
- ifeq ($(shell test -x "`which $(GOIMPORTS)`"; echo $$?),0)
+ ifeq ($(shell test -x "`command -v $(GOIMPORTS)`"; echo $$?),0)
  fmt : $(SOURCES) | lint
 -	@$(GOIMPORTS) $(GOIMPORTS_EXTRA_OPTS) $?;
-+	#@$(GOIMPORTS) $(GOIMPORTS_EXTRA_OPTS) $?;
++	@echo "delete this step"
  else
  fmt : $(SOURCES) | lint
  	@echo "git-lfs: skipping fmt, no goimports found at \`$(GOIMPORTS)\` ..."
-@@ -513,13 +513,13 @@ endif
+@@ -607,13 +607,7 @@ endif
  # are vendored in via vendor (see: above).
  .PHONY : lint
  lint : $(SOURCES)
@@ -60,16 +69,10 @@ index bd83e21..4d47289 100644
 -		{{ end }}' \
 -	| $(GREP) -v "github.com/git-lfs/git-lfs" \
 -	| $(GREP) "."
-+	#@! $(GO) list -f '{{ join .Deps "\n" }}' . \
-+	#| $(XARGS) $(GO) list -f \
-+	#	'{{ if and (not .Standard) (not .Module) }} \
-+	#		{{ .ImportPath }} \
-+	#	{{ end }}' \
-+	#| $(GREP) -v "github.com/git-lfs/git-lfs" \
-+	#| $(GREP) "."
++	@echo "delete this step"
  
- # MAN_ROFF_TARGETS is a list of all ROFF-style targets in the man pages.
- MAN_ROFF_TARGETS = man/git-lfs-checkout.1 \
+ # generate index.txt for ronn HTML man page link generation
+ .PHONY : index.txt
 -- 
-2.25.1
+2.33.0
 
diff --git a/git-lfs-v2.12.0.tar.gz b/git-lfs-v2.12.0.tar.gz
deleted file mode 100644
index 8c968371e4965b275f0e60e7f5fe8758eb9c4e86..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/git-lfs-v3.2.0.tar.gz b/git-lfs-v3.2.0.tar.gz
new file mode 100644
index 0000000000000000000000000000000000000000..3231343f3c9329fd48aba9f7b13913687cc46d21
GIT binary patch
diff --git a/git-lfs.spec b/git-lfs.spec
index 3a3a965..e2c471a 100644
--- a/git-lfs.spec
+++ b/git-lfs.spec
@@ -3,8 +3,8 @@
 
 # https://github.com/git-lfs/git-lfs
 Name:           git-lfs
-Version:        2.12.0
-Release:        2
+Version:        3.2.0
+Release:        1
 Summary:        Git extension for versioning large files
 
 License:        MIT and BSD and Apache-2.0 and MPL-2.0
@@ -53,8 +53,5 @@ install -Dpm0755 src/github.com/git-lfs/git-lfs/bin/git-lfs %{buildroot}%{_bindi
 
 
 %changelog
-* Mon Dec 13 2021 zhaoshuang <zhaoshuang@uniontech.com> - 2.12.0-2
-- remove "%{dist}" from spec file
-
-* Sat Sep 19 2020 zhoukang <gameoverboss@163.com> - 2.12.0-1
+* Tue Jul 12 2022 zhoukang <gameoverboss@163.com> - 3.2.0-1
 - Initial package
-- 
2.31.1