From 1ee7e37c71364dbaa4b9b8d840699ce838cdc4df Mon Sep 17 00:00:00 2001
From: Chuan Zheng <zhengchuan@huawei.com>
Date: Tue, 17 Nov 2020 14:50:56 +0800
Subject: [PATCH build and enhance 4/8] libcare-cc: -I is no need to skip,
 remove it

Change-Id: Id2b214c2ccdf1fd5080ba1b10c23587bcec28f4b
Signed-off-by: imxcc <xingchaochao@huawei.com>
---
 libcare.spec     |  5 +++-
 libcareplus.spec | 59 +++++++++++++++++++++++++++++++++++-------------
 src/kpatch_cc.c  |  3 ---
 3 files changed, 47 insertions(+), 20 deletions(-)

diff --git a/libcare.spec b/libcare.spec
index 5276654..0c0ebf9 100644
--- a/libcare.spec
+++ b/libcare.spec
@@ -1,7 +1,7 @@
 Version: 0.1.4
 Name: libcare
 Summary: LibCare tools
-Release: 5%{?dist}
+Release: 6%{?dist}
 Group: Applications/System
 License: GPLv2
 Url: http://www.cloudlinux.com
@@ -158,6 +158,9 @@ exit 0
 %endif
 
 %changelog
+* Wed Sep 22 2021 Chuan Zheng <zhengchuan@huawei.com> - 0.1.4-6
+- libcare-cc: remove -I skip
+
 * Wed Sep 22 2021 Chuan Zheng <zhengchuan@huawei.com> - 0.1.4-5
 - libcare-cc: add gcc iquote option support
 
diff --git a/libcareplus.spec b/libcareplus.spec
index 5925aed..3f36db1 100644
--- a/libcareplus.spec
+++ b/libcareplus.spec
@@ -1,12 +1,11 @@
 Version: 0.1.4
 Name: libcareplus
-Summary: LibcarePlus tools
-Release: 2%{?dist}
+Summary: Libcare tools
+Release: 6%{?dist}
 Group: Applications/System
 License: GPLv2
-Url: https://gitee.com/openeuler/libcareplus
-Source0: %{name}-%{version}.tar.gz
-ExclusiveArch: x86_64
+Url: http://www.cloudlinux.com
+Source0: %{name}-%{version}.tar.bz2
 BuildRequires: elfutils-libelf-devel libunwind-devel
 
 %if 0%{with selinux}
@@ -22,35 +21,34 @@ Requires:      libcare-selinux = %{version}-%{release}
 %endif
 
 %description
-LibcarePlus userland tools
+LibCare userland tools
 
 %if 0%{with selinux}
 
 %package selinux
-Summary: SELinux package for LibcarePlus/QEMU integration
+Summary: SELinux package for LibCare/QEMU integration
 Group: System Environment/Base
 Requires(post): selinux-policy-base, policycoreutils
 Requires(postun): policycoreutils
 %description selinux
 This package contains SELinux module required to allow for
-LibcarePlus interoperability with the QEMU run by sVirt.
+LibCare interoperability with the QEMU run by sVirt.
 
 %endif
 
 
 %package devel
-Summary: LibcarePlus development package
+Summary: LibCare development package
 Group: System Environment/Development Tools
 %description devel
-LibcarePlus devel files.
+LibCare devel files.
 
 
 %prep
-%setup -q
-%autopatch -p1
+%setup -c -n %{name}-%{version}
 
 %build
-
+./src/configure
 make -C src
 %if 0%{with selinux}
 make -C dist/selinux
@@ -160,8 +158,37 @@ exit 0
 %endif
 
 %changelog
-* Mon Apr 26 2021 Chuan Zheng <zhengchuan@huawei.com>
+* Wed Sep 22 2021 Chuan Zheng <zhengchuan@huawei.com> - 0.1.4-6
+- libcare-cc: remove -I skip
+
+* Wed Sep 22 2021 Chuan Zheng <zhengchuan@huawei.com> - 0.1.4-5
+- libcare-cc: add gcc iquote option support
+
+* Wed Sep 22 2021 Chuan Zheng <zhengchuan@huawei.com> - 0.1.4-4
+- make configure before build
+
+* Wed Sep 22 2021 Chuan Zheng <zhengchuan@huawei.com> - 0.1.4-3
+- adapt spec and makefile to make obs rpmbuild happy
+
+* Mon Apr 26 2021 Chuan Zheng <zhengchuan@huawei.com> - 0.1.4-2
 - gensrc: skip vector instruction in str_do_gotpcrel
 
-* Tue Dec 8 2020 Ying Fang <fangying1@huawei.com>
-- Init the libcareplus package spec
+* Tue Jan 02 2018 Pavel Boldin <pboldin@cloudlinux.com> - 0.1.4-1
+- fix libcare service verbosity
+
+* Wed Dec 27 2017 Pavel Boldin <pboldin@cloudlinux.com> - 0.1.3-1
+- use systemd's libcare.socket
+- use libcare-client default's path
+
+* Mon Dec 25 2017 Pavel Boldin <pboldin@cloudlinux.com> - 0.1.2-1
+- add code executing after/before scripts
+- spec: exec systemctl's hooks
+- fix files in /run
+
+* Mon Dec 11 2017 Pavel Boldin <pboldin@cloudlinux.com> - 0.1.1-1
+- add libcare-client
+- add systemd startup script
+- add selinux support so we can patch RHEL7's QEMU's
+
+* Mon Dec 11 2017 Pavel Boldin <pboldin@cloudlinux.com> - 0.1-1
+- first version
diff --git a/src/kpatch_cc.c b/src/kpatch_cc.c
index 8412346..494bdaf 100644
--- a/src/kpatch_cc.c
+++ b/src/kpatch_cc.c
@@ -413,9 +413,6 @@ static void init(int argc_, const char **argv_)
 		case 'T':
 			i++;
 			continue;
-		case 'I':
-			i++;
-			continue;
 		case '-':
 			if (strcmp(arg + 2, "version") == 0) {
 				action = SHOW_VERSION;
-- 
2.19.1